/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
	"time"
)

// checks if the CustomHandler type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CustomHandler{}

// CustomHandler struct for CustomHandler
type CustomHandler struct {
	Id string `json:"id"`
	ChannelId string `json:"channel_id"`
	Type string `json:"type"`
	Url string `json:"url"`
	Secret *string `json:"secret,omitempty"`
	SecretHeader *string `json:"secret_header,omitempty"`
	SecretConfigured bool `json:"secret_configured"`
	Attributes map[string]interface{} `json:"attributes,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
	OrganizationId string `json:"organization_id"`
}

// NewCustomHandler instantiates a new CustomHandler object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCustomHandler(id string, channelId string, type_ string, url string, secretConfigured bool, createdAt time.Time, updatedAt time.Time, organizationId string) *CustomHandler {
	this := CustomHandler{}
	this.Id = id
	this.ChannelId = channelId
	this.Type = type_
	this.Url = url
	this.SecretConfigured = secretConfigured
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	this.OrganizationId = organizationId
	return &this
}

// NewCustomHandlerWithDefaults instantiates a new CustomHandler object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCustomHandlerWithDefaults() *CustomHandler {
	this := CustomHandler{}
	return &this
}

// GetId returns the Id field value
func (o *CustomHandler) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *CustomHandler) SetId(v string) {
	o.Id = v
}

// GetChannelId returns the ChannelId field value
func (o *CustomHandler) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *CustomHandler) SetChannelId(v string) {
	o.ChannelId = v
}

// GetType returns the Type field value
func (o *CustomHandler) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *CustomHandler) SetType(v string) {
	o.Type = v
}

// GetUrl returns the Url field value
func (o *CustomHandler) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *CustomHandler) SetUrl(v string) {
	o.Url = v
}

// GetSecret returns the Secret field value if set, zero value otherwise.
func (o *CustomHandler) GetSecret() string {
	if o == nil || IsNil(o.Secret) {
		var ret string
		return ret
	}
	return *o.Secret
}

// GetSecretOk returns a tuple with the Secret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetSecretOk() (*string, bool) {
	if o == nil || IsNil(o.Secret) {
		return nil, false
	}
	return o.Secret, true
}

// HasSecret returns a boolean if a field has been set.
func (o *CustomHandler) HasSecret() bool {
	if o != nil && !IsNil(o.Secret) {
		return true
	}

	return false
}

// SetSecret gets a reference to the given string and assigns it to the Secret field.
func (o *CustomHandler) SetSecret(v string) {
	o.Secret = &v
}

// GetSecretHeader returns the SecretHeader field value if set, zero value otherwise.
func (o *CustomHandler) GetSecretHeader() string {
	if o == nil || IsNil(o.SecretHeader) {
		var ret string
		return ret
	}
	return *o.SecretHeader
}

// GetSecretHeaderOk returns a tuple with the SecretHeader field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetSecretHeaderOk() (*string, bool) {
	if o == nil || IsNil(o.SecretHeader) {
		return nil, false
	}
	return o.SecretHeader, true
}

// HasSecretHeader returns a boolean if a field has been set.
func (o *CustomHandler) HasSecretHeader() bool {
	if o != nil && !IsNil(o.SecretHeader) {
		return true
	}

	return false
}

// SetSecretHeader gets a reference to the given string and assigns it to the SecretHeader field.
func (o *CustomHandler) SetSecretHeader(v string) {
	o.SecretHeader = &v
}

// GetSecretConfigured returns the SecretConfigured field value
func (o *CustomHandler) GetSecretConfigured() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.SecretConfigured
}

// GetSecretConfiguredOk returns a tuple with the SecretConfigured field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetSecretConfiguredOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SecretConfigured, true
}

// SetSecretConfigured sets field value
func (o *CustomHandler) SetSecretConfigured(v bool) {
	o.SecretConfigured = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *CustomHandler) GetAttributes() map[string]interface{} {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]interface{}
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetAttributesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Attributes) {
		return map[string]interface{}{}, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *CustomHandler) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]interface{} and assigns it to the Attributes field.
func (o *CustomHandler) SetAttributes(v map[string]interface{}) {
	o.Attributes = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *CustomHandler) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *CustomHandler) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *CustomHandler) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *CustomHandler) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *CustomHandler) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *CustomHandler) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *CustomHandler) SetOrganizationId(v string) {
	o.OrganizationId = v
}

func (o CustomHandler) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CustomHandler) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["type"] = o.Type
	toSerialize["url"] = o.Url
	if !IsNil(o.Secret) {
		toSerialize["secret"] = o.Secret
	}
	if !IsNil(o.SecretHeader) {
		toSerialize["secret_header"] = o.SecretHeader
	}
	toSerialize["secret_configured"] = o.SecretConfigured
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	toSerialize["organization_id"] = o.OrganizationId
	return toSerialize, nil
}

type NullableCustomHandler struct {
	value *CustomHandler
	isSet bool
}

func (v NullableCustomHandler) Get() *CustomHandler {
	return v.value
}

func (v *NullableCustomHandler) Set(val *CustomHandler) {
	v.value = val
	v.isSet = true
}

func (v NullableCustomHandler) IsSet() bool {
	return v.isSet
}

func (v *NullableCustomHandler) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCustomHandler(val *CustomHandler) *NullableCustomHandler {
	return &NullableCustomHandler{value: val, isSet: true}
}

func (v NullableCustomHandler) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCustomHandler) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


